﻿@{
    Layout = "~/Views/Shared/_Layout.cshtml";
}

@section scripts{
    <script>
        $(document).ready(function () {
            var source =
                {
                    datafields:
                    [
                        { name: 'Id',       type: 'number' },
                        { name: 'Name',     type: 'string' },
                        { name: 'Lastname', type: 'string' },
                        { name: 'Email',    type: 'string' },
                        { name: 'Active',   type: 'number' },
                        { name: 'RoleId',   type: 'number' },
                        { name: 'RoleName', type: 'number' },
                    ],
                    datatype: "json",
                    url: "/Account/GetAdmins",
                    filter: function () {
                        $("#jqxgrid").jqxGrid('updatebounddata', 'filter');
                    },
                    // update the grid and send a request to the server.
                    sort: function () {
                        $("#jqxgrid").jqxGrid('updatebounddata', 'sort');
                    },
                    root: "Rows",
                    beforeprocessing: function (data) {
                        source.totalrecords = data.TotalRows;
                    }
                };

            var dataAdapter = new $.jqx.dataAdapter(source);

            var columnsrenderer = function (value) {
                return '<div style="text-align: center; margin-top:10px;"><b>' + value + '</b></div>';
            }

            $("#jqxgrid").jqxGrid(
                {
                    width           : "100%",
                    source          : dataAdapter,
                    showfilterrow   : true,
                    editable        : false,
                    filterable      : true,
                    pageable        : true,
                    sortable        : true,
                    pagesize        : 20,
                    autoheight      : true,
                    virtualmode     : true,
                    selectionmode   : 'multiplecellsextended',
                    rendergridrows  : function (obj) {
                        return obj.data;
                    },
                    columns:
                    [
                        { text: 'Name', datafield: 'Name', filtertype: 'textbox', width: "15%", renderer: columnsrenderer, sortable: true },
                        { text: 'Lastname', datafield: 'Lastname', filtertype: 'textbox', width: "15%", renderer: columnsrenderer, sortable: true },
                        { text: 'Email', datafield: 'Email', filtertype: 'textbox', width: "25%", renderer: columnsrenderer, sortable: true },
                        {
                            text: 'Role', datafield: 'RoleName', filtertype: 'textbox', width: "15%", cellsalign: 'center', renderer: columnsrenderer, sortable: true, columntype: 'dropdownlist',
                            createeditor: function (row, value, editor) {
                                editor.jqxDropDownList({ source: rolesAdapter, displayMember: 'RoleName', valueMember: 'RoleId' });
                            }
                        },
                        {
                            text: 'Active', datafield: 'Active', filtertype: 'textbox', width: "10%", cellsalign: 'center', renderer: columnsrenderer, sortable: true,
                            validation: function (cell, value) {
                                if (value > 1 || value < 0) {
                                    return { result: false, message: "Must either be 0 or 1!" };
                                }
                                return true;
                            }
                        },
                        {
                            text: 'Edit', datafield: 'Edit', columntype: 'button', width: '10%', filterable: false, renderer: columnsrenderer, cellsrenderer: function () {
                                return "Edit";
                            }, buttonclick: function (row) {
                                editrowindex = row;
                                var id = $("#jqxgrid").jqxGrid('getcellvalue', row, "Id");
                                window.location = '/Account/Edit/' + id;
                            }
                        },
                        {
                            text: 'Delete', datafield: 'Delete', columntype: 'button', width: '10%', filterable: false, renderer: columnsrenderer, cellsrenderer: function () {
                                return "Delete";
                            }, buttonclick: function (row) {
                                var response = confirm("Are you sure?");
                                if (response==true) {
                                    var id = $("#jqxgrid").jqxGrid('getcellvalue', row, "Id");
                                    $.ajax({
                                        dataType : 'json',
                                        cache    : false,
                                        url      : '/Account/Delete/' + id,
                                        type     : "POST",
                                        success  : function (data, status, xhr) {
                                            $("#jqxgrid").jqxGrid('deleterow', row);
                                        },
                                        error    : function (jqXHR, textStatus, errorThrown) {
                                            alert(jqXHR.statusText);
                                        }
                                    });
                                }
                            }
                        }
                    ]
                });
        });
    </script>
}

<div class="column">
    <div class="menu" style="text-align:left; color:black">
        <h2 style="width:100%; margin-left: 0 auto; margin-right:0 auto;">Admin Users</h2>
        <div id="jqxgrid" style="width: 100% !important; margin-top:-20px;"></div>
    </div>

    <div style="margin-top:15px;" align="left">
        <a href="/Account/CreateAdmin" class="button active" style="font-size:13px; min-width:50px !important; width:170px; height:60px">Create New Admin</a>
    </div>
</div>
